/*****************************************************************/
/*                                                               */
/*       PixEdit :: PixEdit.c                                    */
/*                                                               */
/*   Author       LePhenixNoir                                   */
/*   Description  Field editor for the game of life              */
/*                                                               */
/*****************************************************************/

#include <stdlib.h>
#include "fxlib.h"
#include "PixEdit.h"

unsigned int key;
unsigned char *image;

void PixEdit_SetImage(unsigned char *img)
{
  image = img;
}

void PixEdit_View()
{
  extern unsigned char *Disp_VRAM;
  int i;

  Disp_Clear();
  for(i=0;i<1024;i++) *(Disp_VRAM+i) = *(image+i);
  do GetKey(&key); while(key-30014);
}

int PixEdit_Edit()
{
  int i,j,k;
  int lx = 642;
  int ly = 322;
  int x=11, y=5;
  int ox=52, oy=27;
  int redraw = 1;

  Bkey_Set_RepeatTime(4,1);

  while(1)
  {
    if(redraw)
    {
      Disp_Clear();
      for(i=0;i<=11;i++) for(j=24;j>=0;j--) if(PixEdit_GetPixel(j+ox,i+oy)) for(k=0;k<4;k++)
        Bdisp_DrawLineVRAM(5*j+2,5*i+k+2,5*j+5,5*i+k+2);

      Bdisp_DrawLineVRAM(0,-5*oy,lx-5*ox,-5*oy);
      Bdisp_DrawLineVRAM(-5*ox,0,-5*ox,ly-5*oy);
      Bdisp_DrawLineVRAM(lx-5*ox,0,lx-5*ox,ly-5*oy);
      Bdisp_DrawLineVRAM(0,ly-5*oy,lx-5*ox,ly-5*oy);
      SaveDisp(1);
    }
    else RestoreDisp(1);

    Bdisp_DrawLineVRAM(5*x+1,5*y+1,5*x+6,5*y+1);
    Bdisp_DrawLineVRAM(5*x+1,5*y+1,5*x+1,5*y+6);
    Bdisp_DrawLineVRAM(5*x+6,5*y+1,5*x+6,5*y+6);
    Bdisp_DrawLineVRAM(5*x+1,5*y+6,5*x+6,5*y+6);

    redraw = 0;
    while(1)
    {
      GetKey(&key);
      if(key==30002) break;
      if(key==30004 || key==30009 || key==30010 || key==30014) {
        redraw=1; break; }
      if(key==30018 && y+oy) break;
      if(key==30020 && x+ox) break;
      if(key==30021 && x-127+ox) break;
      if(key==30023 && y-63+oy) break;
    }

    switch(key) {
      case 30002: Bkey_Set_RepeatTime_Default(); return 0;
      case 30004: PixEdit_SetPixel(x+ox,y+oy,!PixEdit_GetPixel(x+ox,y+oy)); break;
      case 30009: PixEdit_SetPixel(x+ox,y+oy,1); break;
      case 30010: PixEdit_SetPixel(x+ox,y+oy,0); break;
      case 30014: PixEdit_View(); break;
      case 30018: if(y> 0) y--; else { oy--; redraw=1; } break;
      case 30020: if(x> 0) x--; else { ox--; redraw=1; } break;
      case 30021: if(x<24) x++; else { ox++; redraw=1; } break;
      case 30023: if(y<11) y++; else { oy++; redraw=1; } break; }
  }
}

int PixEdit_GetPixel(int x,int y)
{
  return (*(image+(y<<4)+((x-x%8)>>3))>>(7-x%8))&1;
}

void PixEdit_SetPixel(int x,int y,int v)
{
  unsigned char byte = *(image+(y<<4)+((x-x%8)>>3));
  if(v) byte |= (1<<(7-x%8));
  else byte &= ~(1<<(7-x%8));
  *(image+(y<<4)+((x-x%8)>>3)) = byte;
}
